/*
Copyright (C) 1993,96,97 Inujima, Masaru
This file is a part of rhizhome/pi, Qfwfq opus 1

Permission to use, copy, modify, and/or distribute this
program for any purpose is hereby granted, provided that
this copyright notice appears in all copies made of this
program.
Fees for distribution or use of this program or derived
materials may only be charged with prior written consent
of the author.
This program is provided "as is" without any express or
implied warranty.
*/

#ifndef lint
static char rcsid[] = "@(#)$Id: boot.c,v 1.5 1999/03/15 12:57:25 qfwfq Exp $";
#endif
/*
 * $Log: boot.c,v $
 * Revision 1.5  1999/03/15 12:57:25  qfwfq
 * enable -loadable in Win32 Visual C++ environment
 *
 * Revision 1.4  1999/02/15 08:37:14  qfwfq
 * port to Microsoft C compiler
 *
 * Revision 1.3  1998/07/31 10:57:40  qfwfq
 * Adoption to Win32 GUI environment
 *
 * Revision 1.2  1997/04/26 13:29:04  qfwfq
 * Version 0.30 - hygienic macro system with syntax-case
 *
 * Revision 1.1  1996/09/06 06:11:22  qfwfq
 * Version 0.20 unix revision is up.
 * Renamed pi.h to rhiz_pi.h for compiler support.
 * Split scheme.pi to interprt/*.pi files, load them with bootrc.pi.
 *
 */

/*
 * Mock compiled module for bootstrap.
 */
#include "rhiz_pi.h"

#include <stdio.h>
#include <string.h>

RP_ARRAY_FORWARD_DECL rk_object rp_refarray[];

static rk_object rp_c_0;

static rk_object
RpC0(void)
{
	extern rk_object rp_load_proc;

	rk_eval_register[0] = rp_refarray[0];
	rk_eval_register[1] = RK_SOBJ_NIL;
	rk_eval_register[2] = RK_MAKEINUM(1);
	rk_eval_register[3] = RK_DUMMY_OBJ;
	rk_valid_register = 4;
	return	rp_load_proc;
}

rk_object
RpCbootRun(void)
{
	return	rp_c_0;
}

static struct RP_PROCEDURE_REC const rp_c_procedure_rec[] = {
	RpC0, &rp_c_0,
	NULL, NULL
};

static struct RP_STRING_DESC rp_c_o_0[1];

static struct RP_OBJECT_DESC const rp_c_object_desc[] = {
	RP_OTAG_STRING, rp_c_o_0,
	-1, NULL
};

static rk_object rp_refarray[1];

void
RpCbootInit(struct RP_MODULE_INIT *p)
{
	p->rp_nprocs = sizeof(rp_c_procedure_rec)/sizeof(rp_c_procedure_rec[0]) - 1;
	p->rp_procs = rp_c_procedure_rec;
	p->rp_odesc = rp_c_object_desc;
	p->rp_oarray = rp_refarray;
}

RP_DLLEXPORT int const rp_in_windows_subsystem = 0;

static rk_object (* const run[])() = {RpCbootRun};
static void (* const init[])() = {RpCbootInit};

RP_DLLEXPORT struct RP_PROGRAM_DESC const *
RpProgramDesc(void)
{
	static struct RP_PROGRAM_DESC const prog_d = {1, run, init};

	if ((rp_argc -= 2) < 1) {
		fprintf(stderr, "usage: %s boot-program dir args...\n", rp_argv[0]);
		exit(2);
	}
	rp_c_o_0[0].rp_length = strlen((rp_argv += 2)[-1]);
	rp_c_o_0[0].rp_chars = rp_argv[-1];

	return	&prog_d;
}
